/*! typed-dom v0.0.305 https://github.com/falsandtru/typed-dom | (c) 2016, falsandtru | (Apache-2.0 AND MPL-2.0) License */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["typed-dom"] = factory();
	else
		root["typed-dom"] = factory();
})(this, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 406:
/***/ ((__unused_webpack_module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.ObjectSetPrototypeOf = exports.ObjectGetPrototypeOf = exports.ObjectCreate = exports.ObjectAssign = exports.toString = exports.isEnumerable = exports.isPrototypeOf = exports.hasOwnProperty = exports.isArray = exports.sqrt = exports.log = exports.tan = exports.cos = exports.sign = exports.round = exports.random = exports.min = exports.max = exports.floor = exports.ceil = exports.abs = exports.parseInt = exports.parseFloat = exports.isSafeInteger = exports.isNaN = exports.isInteger = exports.isFinite = exports[NaN] = void 0;
exports[NaN] = Number.NaN, exports.isFinite = Number.isFinite, exports.isInteger = Number.isInteger, exports.isNaN = Number.isNaN, exports.isSafeInteger = Number.isSafeInteger, exports.parseFloat = Number.parseFloat, exports.parseInt = Number.parseInt;
exports.abs = Math.abs, exports.ceil = Math.ceil, exports.floor = Math.floor, exports.max = Math.max, exports.min = Math.min, exports.random = Math.random, exports.round = Math.round, exports.sign = Math.sign, exports.cos = Math.cos, exports.tan = Math.tan, exports.log = Math.log, exports.sqrt = Math.sqrt;
exports.isArray = Array.isArray;
exports.hasOwnProperty = Object.prototype.hasOwnProperty.call.bind(Object.prototype.hasOwnProperty);
exports.isPrototypeOf = Object.prototype.isPrototypeOf.call.bind(Object.prototype.isPrototypeOf);
exports.isEnumerable = Object.prototype.propertyIsEnumerable.call.bind(Object.prototype.propertyIsEnumerable);
exports.toString = Object.prototype.toString.call.bind(Object.prototype.toString);
exports.ObjectAssign = Object.assign;
exports.ObjectCreate = Object.create;
exports.ObjectGetPrototypeOf = Object.getPrototypeOf;
exports.ObjectSetPrototypeOf = Object.setPrototypeOf;

/***/ }),

/***/ 112:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.splice = exports.pop = exports.push = exports.shift = exports.unshift = exports.indexOf = void 0;

const global_1 = __webpack_require__(128);

function indexOf(as, a) {
  if (as.length === 0) return -1;
  return a === a ? as.indexOf(a) : as.findIndex(a => a !== a);
}

exports.indexOf = indexOf;

function unshift(as, bs) {
  if ('length' in as) {
    if (global_1.Symbol.iterator in as) return bs.unshift(...as), bs;

    for (let i = as.length; i--;) {
      bs.unshift(as[i]);
    }
  } else {
    bs.unshift(...as);
  }

  return bs;
}

exports.unshift = unshift;

function shift(as, count) {
  if (count < 0) throw new Error('Unexpected negative number');
  return count === void 0 ? [as.shift(), as] : [splice(as, 0, count), as];
}

exports.shift = shift;

function push(as, bs) {
  if ('length' in bs) {
    if (global_1.Symbol.iterator in bs && bs.length > 50) return as.push(...bs), as;

    for (let i = 0, len = bs.length; i < len; ++i) {
      as.push(bs[i]);
    }
  } else {
    for (const b of bs) {
      as.push(b);
    }
  }

  return as;
}

exports.push = push;

function pop(as, count) {
  if (count < 0) throw new Error('Unexpected negative number');
  return count === void 0 ? [as, as.pop()] : [as, splice(as, as.length - count, count)];
}

exports.pop = pop;

function splice(as, index, count, ...values) {
  if (as.length === 0) return push(as, values), [];

  if (index > as.length) {
    index = as.length;
  } else if (index < 0) {
    index = -index > as.length ? 0 : as.length + index;
  }

  count = count > as.length ? as.length : count;
  if (count === 0 && values.length === 0) return [];
  if (count === 1 && values.length === 1) return [[as[index], as[index] = values[0]][0]];

  switch (index) {
    case 0:
      if (count === 0) return unshift(values, as), [];
      if (count === 1) return [[as.shift()], unshift(values, as)][0];
      break;

    case as.length - 1:
      if (count === 1) return [[as.pop()], push(as, values)][0];
      break;

    case as.length:
      return push(as, values), [];
  }

  return arguments.length > 2 ? as.splice(index, count, ...values) : as.splice(index);
}

exports.splice = splice;

/***/ }),

/***/ 529:
/***/ ((__unused_webpack_module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.equal = void 0;

function equal(a, b) {
  return a === a ? a === b : b !== b;
}

exports.equal = equal;

/***/ }),

/***/ 99:
/***/ ((__unused_webpack_module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.duffReduce = exports.duffEach = exports.duffbk = exports.duff = void 0;

function duff(count, proc) {
  if (count > 0) {
    let i = 0,
        m = count & 7,
        d = (count - m) / 8;

    while (m--) {
      proc(i++);
    }

    while (d--) {
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
      proc(i++);
    }
  } else {
    let i = -count,
        m = i & 7,
        d = (i - m) / 8;

    while (m--) {
      proc(--i);
    }

    while (d--) {
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
      proc(--i);
    }
  }
}

exports.duff = duff;

function duffbk(count, proc) {
  if (count > 0) {
    let i = 0,
        m = count & 7,
        d = (count - m) / 8;

    while (m--) {
      if (proc(i++) === false) return;
    }

    while (d--) {
      switch (false) {
        case proc(i++):
        case proc(i++):
        case proc(i++):
        case proc(i++):
        case proc(i++):
        case proc(i++):
        case proc(i++):
        case proc(i++):
          return;
      }
    }
  } else {
    let i = -count,
        m = i & 7,
        d = (i - m) / 8;

    while (m--) {
      if (proc(--i) === false) return;
    }

    while (d--) {
      switch (false) {
        case proc(--i):
        case proc(--i):
        case proc(--i):
        case proc(--i):
        case proc(--i):
        case proc(--i):
        case proc(--i):
        case proc(--i):
          return;
      }
    }
  }
}

exports.duffbk = duffbk;

function duffEach(array, proc) {
  let count = array.length;
  let i = 0,
      m = count & 7,
      d = (count - m) / 8;

  while (m--) {
    proc(array[i], i++, array);
  }

  while (d--) {
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
    proc(array[i], i++, array);
  }
}

exports.duffEach = duffEach; // ベンチマークの10,000以上で急激な速度低下が見られるがNodeListなどでの
// 実際の使用では速度低下は見られない

function duffReduce(array, proc, initial) {
  let count = array.length;
  let i = 0,
      m = count & 7,
      d = (count - m) / 8;
  let acc = initial;

  while (m--) {
    acc = proc(acc, array[i], i++, array);
  }

  while (d--) {
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
    acc = proc(acc, array[i], i++, array);
  }

  return acc;
}

exports.duffReduce = duffReduce;

/***/ }),

/***/ 288:
/***/ ((__unused_webpack_module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.noop = exports.fix = exports.id = exports.clear = exports.singleton = void 0;

function singleton(f) {
  let result;
  return function (...as) {
    if (result) return result[0];
    result = [f.call(this, ...as)];
    return result[0];
  };
}

exports.singleton = singleton;

function clear(f) {
  return (...as) => void f(...as);
}

exports.clear = clear;

function id(a) {
  return a;
}

exports.id = id;

function fix(f) {
  return a1 => {
    const a2 = f(a1);
    return a1 === a2 || a2 !== a2 ? a2 : f(a2);
  };
}

exports.fix = fix; // @ts-ignore

function noop() {}

exports.noop = noop;

/***/ }),

/***/ 128:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



__webpack_require__(921);

const global = void 0 || typeof globalThis !== 'undefined' && globalThis // @ts-ignore
|| typeof self !== 'undefined' && self || Function('return this')();
global.global = global;
module.exports = global;

/***/ }),

/***/ 921:
/***/ (() => {

 // @ts-ignore

var globalThis; // @ts-ignore

var global = (/* unused pure expression or super */ null && (globalThis));

/***/ }),

/***/ 808:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.reduce = exports.memoize = void 0;

const global_1 = __webpack_require__(128);

const alias_1 = __webpack_require__(406);

const compare_1 = __webpack_require__(529);

function memoize(f, identify = (...as) => as[0], memory) {
  if (typeof identify === 'object') return memoize(f, void 0, identify);
  if (memory === void 0) return memoize(f, identify, new global_1.Map());
  if ((0, alias_1.isArray)(memory)) return memoize(f, identify, {
    has(key) {
      return memory[key] !== void 0;
    },

    get(key) {
      return memory[key];
    },

    set(key, value) {
      memory[key] = value;
      return this;
    },

    delete() {
      throw 0;
    }

  });
  let nullish = false;
  return (...as) => {
    const b = identify(...as);
    let z = memory.get(b);
    if (z !== void 0 || nullish && memory.has(b)) return z;
    z = f(...as);
    nullish ||= z === void 0;
    memory.set(b, z);
    return z;
  };
}

exports.memoize = memoize;

function reduce(f, identify = (...as) => as[0]) {
  let key = [];
  let val = [];
  return (...as) => {
    const b = identify(...as);

    if (!(0, compare_1.equal)(key, b)) {
      key = b;
      val = f(...as);
    }

    return val;
  };
}

exports.reduce = reduce;

/***/ }),

/***/ 879:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _a, _b;

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.never = exports.isPromiseLike = exports.Internal = exports.AtomicPromise = exports.internal = void 0;

const global_1 = __webpack_require__(128);

const alias_1 = __webpack_require__(406);

const function_1 = __webpack_require__(288);

exports.internal = Symbol.for('spica/promise::internal');

class AtomicPromise {
  constructor(executor) {
    this[_a] = 'Promise';
    this[_b] = new Internal();

    try {
      executor(value => void this[exports.internal].resolve(value), reason => void this[exports.internal].reject(reason));
    } catch (reason) {
      this[exports.internal].reject(reason);
    }
  }

  static get [Symbol.species]() {
    return AtomicPromise;
  }

  static all(vs) {
    return new AtomicPromise((resolve, reject) => {
      const values = (0, alias_1.isArray)(vs) ? vs : [...vs];
      const results = (0, global_1.Array)(values.length);
      let done = false;
      let count = 0;

      for (let i = 0; !done && i < values.length; ++i) {
        const value = values[i];

        if (!isPromiseLike(value)) {
          results[i] = value;
          ++count;
          continue;
        }

        if (isAtomicPromiseLike(value)) {
          const {
            status
          } = value[exports.internal];

          switch (status.state) {
            case 2
            /* State.fulfilled */
            :
              results[i] = status.value;
              ++count;
              continue;

            case 3
            /* State.rejected */
            :
              return reject(status.reason);
          }
        }

        value.then(value => {
          results[i] = value;
          ++count;
          count === values.length && resolve(results);
        }, reason => {
          reject(reason);
          done = true;
        });
      }

      count === values.length && resolve(results);
    });
  }

  static race(vs) {
    return new AtomicPromise((resolve, reject) => {
      const values = (0, alias_1.isArray)(vs) ? vs : [...vs];

      for (let i = 0; i < values.length; ++i) {
        const value = values[i];

        if (!isPromiseLike(value)) {
          return resolve(value);
        }

        if (isAtomicPromiseLike(value)) {
          const {
            status
          } = value[exports.internal];

          switch (status.state) {
            case 2
            /* State.fulfilled */
            :
              return resolve(status.value);

            case 3
            /* State.rejected */
            :
              return reject(status.reason);
          }
        }
      }

      let done = false;

      for (let i = 0; !done && i < values.length; ++i) {
        const value = values[i];
        value.then(value => {
          resolve(value);
          done = true;
        }, reason => {
          reject(reason);
          done = true;
        });
      }
    });
  }

  static allSettled(vs) {
    return new AtomicPromise(resolve => {
      const values = (0, alias_1.isArray)(vs) ? vs : [...vs];
      const results = (0, global_1.Array)(values.length);
      let count = 0;

      for (let i = 0; i < values.length; ++i) {
        const value = values[i];

        if (!isPromiseLike(value)) {
          results[i] = {
            status: 'fulfilled',
            value: value
          };
          ++count;
          continue;
        }

        if (isAtomicPromiseLike(value)) {
          const {
            status
          } = value[exports.internal];

          switch (status.state) {
            case 2
            /* State.fulfilled */
            :
              results[i] = {
                status: 'fulfilled',
                value: status.value
              };
              ++count;
              continue;

            case 3
            /* State.rejected */
            :
              results[i] = {
                status: 'rejected',
                reason: status.reason
              };
              ++count;
              continue;
          }
        }

        value.then(value => {
          results[i] = {
            status: 'fulfilled',
            value: value
          };
          ++count;
          count === values.length && resolve(results);
        }, reason => {
          results[i] = {
            status: 'rejected',
            reason
          };
          ++count;
          count === values.length && resolve(results);
        });
      }

      count === values.length && resolve(results);
    });
  }

  static any(vs) {
    return new AtomicPromise((resolve, reject) => {
      const values = (0, alias_1.isArray)(vs) ? vs : [...vs];
      const reasons = (0, global_1.Array)(values.length);
      let done = false;
      let count = 0;

      for (let i = 0; !done && i < values.length; ++i) {
        const value = values[i];

        if (!isPromiseLike(value)) {
          return resolve(value);
        }

        if (isAtomicPromiseLike(value)) {
          const {
            status
          } = value[exports.internal];

          switch (status.state) {
            case 2
            /* State.fulfilled */
            :
              return resolve(status.value);

            case 3
            /* State.rejected */
            :
              reasons[i] = status.reason;
              ++count;
              continue;
          }
        }

        value.then(value => {
          resolve(value);
          done = true;
        }, reason => {
          reasons[i] = reason;
          ++count;
          count === values.length && reject(new AggregateError(reasons, 'All promises were rejected'));
        });
      }

      count === values.length && reject(new AggregateError(reasons, 'All promises were rejected'));
    });
  }

  static resolve(value) {
    return new AtomicPromise(resolve => resolve(value));
  }

  static reject(reason) {
    return new AtomicPromise((_, reject) => reject(reason));
  }

  then(onfulfilled, onrejected) {
    return new AtomicPromise((resolve, reject) => this[exports.internal].then(resolve, reject, onfulfilled, onrejected));
  }

  catch(onrejected) {
    return this.then(void 0, onrejected);
  }

  finally(onfinally) {
    return this.then(onfinally, onfinally).then(() => this);
  }

}

exports.AtomicPromise = AtomicPromise;
_a = Symbol.toStringTag, _b = exports.internal;

class Internal {
  constructor() {
    this.status = {
      state: 0
      /* State.pending */

    };
    this.fulfillReactions = [];
    this.rejectReactions = [];
  }

  get isPending() {
    return this.status.state === 0
    /* State.pending */
    ;
  }

  resolve(value) {
    if (this.status.state !== 0
    /* State.pending */
    ) return;

    if (!isPromiseLike(value)) {
      this.status = {
        state: 2
        /* State.fulfilled */
        ,
        value: value
      };
      return this.resume();
    }

    if (isAtomicPromiseLike(value)) {
      const core = value[exports.internal];

      switch (core.status.state) {
        case 2
        /* State.fulfilled */
        :
        case 3
        /* State.rejected */
        :
          this.status = core.status;
          return this.resume();

        default:
          return core.then(() => (this.status = core.status, this.resume()), () => (this.status = core.status, this.resume()));
      }
    }

    this.status = {
      state: 1
      /* State.resolved */
      ,
      promise: value
    };
    return void value.then(value => {
      this.status = {
        state: 2
        /* State.fulfilled */
        ,
        value
      };
      this.resume();
    }, reason => {
      this.status = {
        state: 3
        /* State.rejected */
        ,
        reason
      };
      this.resume();
    });
  }

  reject(reason) {
    if (this.status.state !== 0
    /* State.pending */
    ) return;
    this.status = {
      state: 3
      /* State.rejected */
      ,
      reason
    };
    return this.resume();
  }

  then(resolve, reject, onfulfilled, onrejected) {
    const {
      status,
      fulfillReactions,
      rejectReactions
    } = this;

    switch (status.state) {
      case 2
      /* State.fulfilled */
      :
        if (fulfillReactions.length !== 0) break;
        return call(resolve, reject, resolve, onfulfilled, status.value);

      case 3
      /* State.rejected */
      :
        if (rejectReactions.length !== 0) break;
        return call(resolve, reject, reject, onrejected, status.reason);
    }

    fulfillReactions.push([resolve, reject, resolve, onfulfilled]);
    rejectReactions.push([resolve, reject, reject, onrejected]);
  }

  resume() {
    const {
      status,
      fulfillReactions,
      rejectReactions
    } = this;

    switch (status.state) {
      case 0
      /* State.pending */
      :
      case 1
      /* State.resolved */
      :
        return;

      case 2
      /* State.fulfilled */
      :
        if (rejectReactions.length !== 0) {
          this.rejectReactions = [];
        }

        if (fulfillReactions.length === 0) return;
        react(fulfillReactions, status.value);
        this.fulfillReactions = [];
        return;

      case 3
      /* State.rejected */
      :
        if (fulfillReactions.length !== 0) {
          this.fulfillReactions = [];
        }

        if (rejectReactions.length === 0) return;
        react(rejectReactions, status.reason);
        this.rejectReactions = [];
        return;
    }
  }

}

exports.Internal = Internal;

function react(reactions, param) {
  for (let i = 0; i < reactions.length; ++i) {
    const reaction = reactions[i];
    call(reaction[0], reaction[1], reaction[2], reaction[3], param);
  }
}

function call(resolve, reject, cont, callback, param) {
  if (!callback) return cont(param);

  try {
    resolve(callback(param));
  } catch (reason) {
    reject(reason);
  }
}

function isPromiseLike(value) {
  return value !== null && typeof value === 'object' && typeof value.then === 'function';
}

exports.isPromiseLike = isPromiseLike;

function isAtomicPromiseLike(value) {
  return exports.internal in value;
}

exports.never = new class Never extends Promise {
  static get [Symbol.species]() {
    return Never;
  }

  constructor() {
    super(function_1.noop);
  }

  then() {
    return this;
  }

  catch() {
    return this;
  }

  finally() {
    return this;
  }

}();

/***/ }),

/***/ 325:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.unique = exports.rndAf = exports.rndAP = exports.rnd0_ = exports.rnd0Z = exports.rnd0v = exports.rnd0f = exports.rnd64 = exports.rnd62 = exports.rnd32 = exports.rnd16 = void 0;

const global_1 = __webpack_require__(128);

const bases = [...Array(7)].map((_, i) => 1 << i);
const dict0_ = [...[...Array(36)].map((_, i) => i.toString(36)), ...[...Array(36)].map((_, i) => i.toString(36).toUpperCase()).slice(-26), '-', '_'];
const dictAz = [...[...Array(36)].map((_, i) => i.toString(36).toUpperCase()).slice(-26), ...[...Array(36)].map((_, i) => i.toString(36)).slice(-26)];
exports.rnd16 = cons(16);
exports.rnd32 = cons(32);
exports.rnd62 = cons(62);
exports.rnd64 = cons(64);
exports.rnd0f = conv(exports.rnd16, dict0_);
exports.rnd0v = conv(exports.rnd32, dict0_);
exports.rnd0Z = conv(exports.rnd62, dict0_);
exports.rnd0_ = conv(exports.rnd64, dict0_);
exports.rndAP = conv(exports.rnd16, dictAz);
exports.rndAf = conv(exports.rnd32, dictAz);

function unique(rnd, len, mem) {
  const clear = !mem;
  mem ??= new global_1.Set();
  let limit = 5;
  return () => {
    while (true) {
      for (let i = 0; i < limit; ++i) {
        const r = rnd(len);
        if (mem.has(r)) continue;
        mem.add(r);
        return r;
      }

      clear && mem.clear();
      ++len;
      limit = len < 3 ? limit : 3;
    }
  };
}

exports.unique = unique;

function cons(radix) {
  const base = bases.find(base => base >= radix);
  const len = bases.indexOf(base);
  return () => {
    while (true) {
      const r = random(len);
      if (r < radix) return r;
    }
  };
}

function conv(rnd, dict) {
  return (len = 1) => {
    let acc = '';

    while (len--) {
      acc += dict[rnd()];
    }

    return acc;
  };
}

const buffer = new Uint16Array(512);
const digit = 16;
const masks = bases.map((_, i) => +`0b${'1'.repeat(i) || 0}`);
let index = buffer.length;
let offset = digit;

function random(len) {
  if (index === buffer.length) {
    global_1.crypto.getRandomValues(buffer);
    index = 0;
  }

  if (offset === len) {
    offset = digit;
    return buffer[index++] & masks[len];
  } else if (offset > len) {
    offset -= len;
    return buffer[index] >> offset & masks[len];
  } else {
    offset = digit;
    ++index;
    return random(len);
  }
}

/***/ }),

/***/ 48:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.SVG = exports.HTML = exports.Shadow = exports.API = void 0;

const global_1 = __webpack_require__(128);

const alias_1 = __webpack_require__(406);

const proxy_1 = __webpack_require__(965);

const dom_1 = __webpack_require__(521);

function API(baseFactory, container) {
  return new global_1.Proxy(() => 0, handle(baseFactory, container));
}

exports.API = API;
exports.Shadow = API(dom_1.html, dom_1.shadow);
exports.HTML = API(dom_1.html);
exports.SVG = API(dom_1.svg);

function handle(baseFactory, container) {
  return {
    apply(target, _, [tag, ...args]) {
      return this.get(target, tag, target)(...args);
    },

    get: (target, prop) => target[prop] || prop in target || typeof prop !== 'string' ? target[prop] : target[prop] = builder(prop)
  };

  function builder(tag) {
    return function build(attrs, children, factory) {
      if (typeof children === 'function') return build(attrs, void 0, children);
      if (typeof attrs === 'function') return build(void 0, void 0, attrs);
      if (isElChildren(attrs)) return build(void 0, attrs, factory);
      const el = elem(tag, factory, attrs, children);
      return new proxy_1.ElementProxy(tag, el, children, container?.(el));
    };
  }

  function elem(tag, factory, attrs, children) {
    const el = factory ? (0, dom_1.define)(factory(baseFactory, tag, attrs ?? {}, children), attrs) : baseFactory(tag, attrs);
    if (tag.toLowerCase() !== el.tagName.toLowerCase()) throw new Error(`TypedDOM: Expected tag name is "${tag.toLowerCase()}" but actually "${el.tagName.toLowerCase()}".`);
    return el;
  }
}

function isElChildren(value) {
  if (value === void 0) return false;
  if (value[global_1.Symbol.iterator]) return true;
  if (typeof value['nodeType'] === 'number') return true;

  for (const name in value) {
    if (!(0, alias_1.hasOwnProperty)(value, name)) continue;
    const val = value[name];
    return !!val && typeof val === 'object';
  }

  return false;
}

/***/ }),

/***/ 965:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



var _a;

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.ElementProxy = void 0;

const global_1 = __webpack_require__(128);

const alias_1 = __webpack_require__(406);

const identity_1 = __webpack_require__(670);

const array_1 = __webpack_require__(112);

var symbols;

(function (symbols) {
  symbols.proxy = Symbol.for('typed-dom::proxy');
  symbols.events = Symbol.for('typed-dom::events');
})(symbols || (symbols = {}));

let id = (0, identity_1.identity)();
let counter = 0;

class ElementProxy {
  constructor(tag, element, children, container = element) {
    this.tag = tag;
    this.element = element;
    this.$id = '';
    this.$query = '';
    this.isObserverUpdate = false;
    this.isInit = true;
    this[_a] = new Events(this.element);
    this.container = container;
    this.$children = children;
    const type = typeof children;

    switch (true) {
      case type === 'undefined':
        this.type = 0
        /* ElChildType.Void */
        ;
        break;

      case type === 'string':
        this.type = 1
        /* ElChildType.Text */
        ;
        break;

      case type === 'object' && typeof children['nodeType'] === 'number':
        this.type = 2
        /* ElChildType.Node */
        ;
        break;

      case (0, alias_1.isArray)(children):
        this.type = 3
        /* ElChildType.Array */
        ;
        break;

      case type === 'object':
        this.type = 4
        /* ElChildType.Struct */
        ;
        break;

      default:
        throw new Error(`TypedDOM: Invalid children type.`);
    }

    throwErrorIfNotUsable(this);
    this.element[symbols.proxy] = this;

    switch (this.type) {
      case 0
      /* ElChildType.Void */
      :
        this.isInit = false;
        return;

      case 1
      /* ElChildType.Text */
      :
      case 2
      /* ElChildType.Node */
      :
        this.children = children;
        this.isInit = false;
        return;

      case 3
      /* ElChildType.Array */
      :
        this.$children = [];
        this.children = children;
        this.isInit = false;
        return;

      case 4
      /* ElChildType.Struct */
      :
        this.$children = this.observe(children);
        this.children = children;
        this.isInit = false;
        return;

      default:
        throw new Error(`TypedDOM: Invalid children type.`);
    }
  }

  get id() {
    if (this.$id) return this.$id;
    this.$id = this.element.id;
    if (/^[a-z][\w-]*$/i.test(this.$id)) return this.$id;

    if (counter === 999) {
      id = (0, identity_1.identity)();
      counter = 0;
    }

    this.$id = `rnd-${id}-${++counter}`;
    this.element.classList.add(this.$id);
    return this.$id;
  }

  get query() {
    if (this.$query) return this.$query;

    switch (true) {
      case this.element !== this.container:
        return this.$query = ':host';

      case this.id === this.element.id:
        return this.$query = `#${this.id}`;

      default:
        return this.$query = `.${this.id}`;
    }
  }

  scope(child) {
    if (child.tag.toUpperCase() !== 'STYLE') return;
    const source = child.element.innerHTML;
    if (!source.includes(':scope')) return;
    const style = source.replace(/(^|[>~+,}/])(\s*):scope(?!\w)(?=\s*[A-Za-z#.:[>~+,{/])/g, (...$) => `${$[1]}${$[2]}${this.query}`);
    if (style === source) return;
    child.element.textContent = style;
  }

  observe(children) {
    return global_1.Object.defineProperties(children, global_1.Object.keys(children).reduce((acc, name) => {
      if (name in {}) throw new Error(`TypedDOM: Child names conflicted with the object property names.`);
      let child = children[name];
      acc[name] = {
        configurable: true,
        enumerable: true,

        get() {
          return child;
        },

        set: newChild => {
          if (!this.isObserverUpdate) {
            this.children = {
              [name]: newChild
            };
          } else {
            this.isObserverUpdate = false;
          }

          child = newChild;
        }
      };
      return acc;
    }, {}));
  }

  get children() {
    switch (this.type) {
      case 1
      /* ElChildType.Text */
      :
        return this.container.textContent;

      default:
        return this.$children;
    }
  }

  set children(children) {
    const container = this.container;
    const removedChildren = [];
    const addedChildren = [];
    let isMutated = false;

    switch (this.type) {
      case 0
      /* ElChildType.Void */
      :
        return;

      case 2
      /* ElChildType.Node */
      :
        this.$children = children;
        container.replaceChildren(children);
        return;

      case 1
      /* ElChildType.Text */
      :
        {
          if (this.isInit || !this[symbols.events].mutate) {
            container.textContent = children;
            isMutated = true;
            break;
          }

          const newText = children;
          const oldText = this.children;
          if (newText === oldText) break;
          container.textContent = newText;
          isMutated = true;
          break;
        }

      case 3
      /* ElChildType.Array */
      :
        {
          const sourceChildren = children;
          const targetChildren = this.$children;
          isMutated ||= sourceChildren.length !== targetChildren.length;

          for (let i = 0; i < sourceChildren.length; ++i) {
            const newChild = sourceChildren[i];
            const oldChild = targetChildren[i];
            throwErrorIfNotUsable(newChild, this.container);
            isMutated ||= newChild.element !== oldChild.element;

            if (newChild.element.parentNode !== this.element) {
              this.scope(newChild);
              hasConnectionListener(newChild) && addedChildren.push(newChild) && this[symbols.events].add(newChild);
            }
          }

          if (container.firstChild) {
            container.replaceChildren(...sourceChildren.map(c => c.element));
          } else {
            for (let i = 0; i < sourceChildren.length; ++i) {
              container.appendChild(sourceChildren[i].element);
            }
          }

          this.$children = sourceChildren;

          for (let i = 0; i < targetChildren.length; ++i) {
            const oldChild = targetChildren[i];

            if (oldChild.element.parentNode !== container) {
              hasConnectionListener(oldChild) && removedChildren.push(oldChild);
              this[symbols.events].del(oldChild);
            }
          }

          break;
        }

      case 4
      /* ElChildType.Struct */
      :
        {
          if (this.isInit) {
            const sourceChildren = children;

            for (const name in sourceChildren) {
              if (!(0, alias_1.hasOwnProperty)(sourceChildren, name)) continue;
              const newChild = sourceChildren[name];
              throwErrorIfNotUsable(newChild, this.container);
              this.scope(newChild);
              newChild.element.parentNode !== container && container.appendChild(newChild.element);
              hasConnectionListener(newChild) && addedChildren.push(newChild) && this[symbols.events].add(newChild);
              isMutated = true;
            }

            break;
          }

          const sourceChildren = children;
          const targetChildren = this.$children;
          if (sourceChildren === targetChildren) break;

          for (const name in sourceChildren) {
            if (!(0, alias_1.hasOwnProperty)(sourceChildren, name)) continue;
            const newChild = sourceChildren[name];
            const oldChild = targetChildren[name];
            if (!newChild || !oldChild) continue;
            if (newChild === oldChild) continue;
            throwErrorIfNotUsable(newChild, this.container);

            if (newChild !== oldChild && newChild.element.parentNode !== oldChild.element.parentNode) {
              this.scope(newChild);
              container.replaceChild(newChild.element, oldChild.element);
              hasConnectionListener(newChild) && addedChildren.push(newChild) && this[symbols.events].add(newChild);
              hasConnectionListener(oldChild) && removedChildren.push(oldChild);
              this[symbols.events].del(oldChild);
            } else {
              const ref = newChild.element.nextSibling;
              container.insertBefore(newChild.element, oldChild.element);
              container.insertBefore(oldChild.element, ref);
            }

            isMutated = true;
            this.isObserverUpdate = true;
            targetChildren[name] = newChild;
            this.isObserverUpdate = false;
          }

          break;
        }
    }

    this.dispatchDisconnectEvent(removedChildren);
    this.dispatchConnectEvent(addedChildren);

    if (isMutated && this[symbols.events].mutate) {
      this.element.dispatchEvent(new global_1.Event('mutate', {
        bubbles: false,
        cancelable: true
      }));
    }
  }

  get isConnected() {
    return !!this.element.parentNode && this.element.isConnected;
  }

  dispatchConnectEvent(listeners = this[symbols.events].listeners) {
    if (listeners.length === 0) return;
    if (listeners !== this[symbols.events].listeners && !this.isConnected) return;

    for (const listener of listeners) {
      listener.element[symbols.proxy].dispatchConnectEvent();
      getEvents(listener).connect && listener.element.dispatchEvent(new global_1.Event('connect', {
        bubbles: false,
        cancelable: true
      }));
    }
  }

  dispatchDisconnectEvent(listeners = this[symbols.events].listeners) {
    if (listeners.length === 0) return;
    if (listeners !== this[symbols.events].listeners && !this.isConnected) return;

    for (const listener of listeners) {
      listener.element[symbols.proxy].dispatchDisconnectEvent();
      getEvents(listener).disconnect && listener.element.dispatchEvent(new global_1.Event('disconnect', {
        bubbles: false,
        cancelable: true
      }));
    }
  }

}

exports.ElementProxy = ElementProxy;
_a = symbols.events;

class Events {
  constructor(element) {
    this.element = element;
    this.listeners = [];
  }

  get mutate() {
    return 'onmutate' in this.element && this.element['onmutate'] != null;
  }

  get connect() {
    return 'onconnect' in this.element && this.element['onconnect'] != null;
  }

  get disconnect() {
    return 'ondisconnect' in this.element && this.element['ondisconnect'] != null;
  }

  add(child) {
    const i = this.listeners.indexOf(child);
    ~i || this.listeners.push(child);
  }

  del(child) {
    const i = this.listeners.indexOf(child);
    ~i && (0, array_1.splice)(this.listeners, i, 1);
  }

}

function hasConnectionListener(child) {
  const events = getEvents(child);
  return events.listeners.length > 0 || events.connect || events.disconnect;
}

function getEvents(child) {
  return child[symbols.events] ?? child.element[symbols.proxy][symbols.events];
}

function throwErrorIfNotUsable(child, newParent) {
  const oldParent = child.element.parentNode;
  if (!oldParent || oldParent === newParent || !(symbols.proxy in oldParent)) return;
  throw new Error(`TypedDOM: Proxy children must be removed from the old parent proxy before assigning to the new parent proxy.`);
}

/***/ }),

/***/ 521:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.defrag = exports.prepend = exports.append = exports.isChildren = exports.define = exports.element = exports.text = exports.svg = exports.html = exports.frag = exports.shadow = void 0;

const global_1 = __webpack_require__(128);

const alias_1 = __webpack_require__(406);

const memoize_1 = __webpack_require__(808);

var caches;

(function (caches) {
  caches.shadows = new WeakMap();
  caches.shadow = (0, memoize_1.memoize)((el, opts) => el.attachShadow(opts), caches.shadows);
  caches.fragment = global_1.document.createDocumentFragment();
})(caches || (caches = {}));

function shadow(el, opts, children, factory = exports.html) {
  if (typeof el === 'string') return shadow(factory(el), opts, children, factory);
  if (typeof opts === 'function') return shadow(el, void 0, children, opts);
  if (typeof children === 'function') return shadow(el, opts, void 0, children);
  if (isChildren(opts)) return shadow(el, void 0, opts, factory);
  return defineChildren(!opts ? el.shadowRoot ?? caches.shadows.get(el) ?? el.attachShadow({
    mode: 'open'
  }) : opts.mode === 'open' ? el.shadowRoot ?? el.attachShadow(opts) : caches.shadows.get(el) ?? caches.shadow(el, opts), children);
}

exports.shadow = shadow;

function frag(children) {
  return defineChildren(caches.fragment.cloneNode(true), children);
}

exports.frag = frag;
exports.html = element(global_1.document, "HTML"
/* NS.HTML */
);
exports.svg = element(global_1.document, "SVG"
/* NS.SVG */
);

function text(source) {
  return global_1.document.createTextNode(source);
}

exports.text = text;

function element(context, ns) {
  return (tag, attrs, children) => {
    const el = elem(context, ns, tag);
    return !attrs || isChildren(attrs) ? defineChildren(el, attrs ?? children) : defineChildren(defineAttrs(el, attrs), children);
  };
}

exports.element = element;

function elem(context, ns, tag) {
  if (!('createElement' in context)) throw new Error(`TypedDOM: Scoped custom elements are not supported on this browser.`);

  switch (ns) {
    case "HTML"
    /* NS.HTML */
    :
      return context.createElement(tag);

    case "SVG"
    /* NS.SVG */
    :
      return context.createElementNS('http://www.w3.org/2000/svg', tag);

    case "MathML"
    /* NS.MathML */
    :
      return context.createElementNS('http://www.w3.org/1998/Math/MathML', tag);
  }
}

function define(node, attrs, children) {
  // Bug: TypeScript
  // Need the next type assertions to suppress an impossible type error on dependent projects.
  // Probably caused by typed-query-selector.
  //
  //   typed-dom/dom.ts(113,3): Error TS2322: Type 'ParentNode & Node' is not assignable to type 'E'.
  //     'E' could be instantiated with an arbitrary type which could be unrelated to 'ParentNode & Node'.
  //
  return !attrs || isChildren(attrs) ? defineChildren(node, attrs ?? children) : defineChildren(defineAttrs(node, attrs), children);
}

exports.define = define;

function defineAttrs(el, attrs) {
  for (const name in attrs) {
    if (!(0, alias_1.hasOwnProperty)(attrs, name)) continue;
    const value = attrs[name];

    switch (typeof value) {
      case 'string':
        el.setAttribute(name, value);

        if (name.startsWith('on')) {
          const type = name.slice(2).toLowerCase();

          switch (type) {
            case 'mutate':
            case 'connect':
            case 'disconnect':
              const prop = `on${type}`;
              el[prop] ?? global_1.Object.defineProperty(el, prop, {
                configurable: true,
                enumerable: false,
                writable: true,
                value: prop in el && !(0, alias_1.hasOwnProperty)(el, prop) ? ev => ev.returnValue : ''
              });
          }
        }

        continue;

      case 'function':
        if (name.length < 3) throw new Error(`TypedDOM: Attribute names for event listeners must have an event name but got "${name}".`);
        const names = name.split(/\s+/);

        for (const name of names) {
          if (!name.startsWith('on')) throw new Error(`TypedDOM: Attribute names for event listeners must start with "on" but got "${name}".`);
          const type = name.slice(2).toLowerCase();
          el.addEventListener(type, value, {
            passive: ['wheel', 'mousewheel', 'touchstart', 'touchmove', 'touchend', 'touchcancel'].includes(type)
          });

          switch (type) {
            case 'mutate':
            case 'connect':
            case 'disconnect':
              const prop = `on${type}`;
              el[prop] ?? global_1.Object.defineProperty(el, prop, {
                configurable: true,
                enumerable: false,
                writable: true,
                value: prop in el && !(0, alias_1.hasOwnProperty)(el, prop) ? ev => ev.returnValue : ''
              });
          }
        }

        continue;

      case 'object':
        el.removeAttribute(name);
        continue;

      default:
        continue;
    }
  }

  return el;
}

function defineChildren(node, children) {
  if (children === void 0) return node;

  if (typeof children === 'string') {
    node.textContent = children;
  } else if ((0, alias_1.isArray)(children) && !node.firstChild) {
    for (let i = 0; i < children.length; ++i) {
      const child = children[i];
      typeof child === 'object' ? node.appendChild(child) : node.append(child);
    }
  } else {
    node.replaceChildren(...children);
  }

  return node;
}

function isChildren(value) {
  return !!value?.[global_1.Symbol.iterator];
}

exports.isChildren = isChildren;

function append(node, children) {
  if (children === void 0) return node;

  if (typeof children === 'string') {
    node.append(children);
  } else {
    for (const child of children) {
      typeof child === 'object' ? node.appendChild(child) : node.append(child);
    }
  }

  return node;
}

exports.append = append;

function prepend(node, children) {
  if (children === void 0) return node;

  if (typeof children === 'string') {
    node.prepend(children);
  } else {
    for (const child of children) {
      typeof child === 'object' ? node.insertBefore(child, null) : node.prepend(child);
    }
  }

  return node;
}

exports.prepend = prepend;

function defrag(nodes) {
  const acc = [];
  let appendable = false;

  for (let i = 0; i < nodes.length; ++i) {
    const node = nodes[i];
    if (node === '') continue;

    if (typeof node === 'string') {
      appendable ? acc[acc.length - 1] += node : acc.push(node);
      appendable = true;
    } else {
      acc.push(node);
      appendable = false;
    }
  }

  return acc;
}

exports.defrag = defrag;

/***/ }),

/***/ 670:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.identity = void 0;

const global_1 = __webpack_require__(128);

const random_1 = __webpack_require__(325);

const ids = Symbol.for('typed-dom::ids');
exports.identity = (0, random_1.unique)(random_1.rnd0Z, 2, global_1.global[ids] ??= new global_1.Set());

/***/ }),

/***/ 251:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.bind = exports.delegate = exports.once = exports.listen = exports.currentTarget = void 0;

const global_1 = __webpack_require__(128);

const alias_1 = __webpack_require__(406);

const promise_1 = __webpack_require__(879);

const function_1 = __webpack_require__(288);

exports.currentTarget = Symbol.for('typed-dom::currentTarget');

function listen(target, selector, type, listener, option) {
  return typeof type === 'string' ? delegate(target, selector, type, listener, option) : bind(target, selector, type, listener);
}

exports.listen = listen;

function once(target, selector, type, listener, option) {
  switch (typeof type) {
    case 'string':
      switch (typeof listener) {
        case 'function':
          return delegate(target, selector, type, listener, { ...(typeof option === 'boolean' ? {
              capture: option
            } : option),
            once: true
          });

        case 'object':
          option = { ...listener,
            once: true
          };
          break;

        default:
          option = {
            once: true
          };
      }

      return new promise_1.AtomicPromise(resolve => void delegate(target, selector, type, resolve, option));

    case 'function':
      return bind(target, selector, type, { ...(typeof listener === 'boolean' ? {
          capture: listener
        } : listener),
        once: true
      });

    case 'object':
      option = { ...type,
        once: true
      };
      break;

    default:
      option = {
        once: true
      };
  }

  return new promise_1.AtomicPromise(resolve => void bind(target, selector, resolve, option));
}

exports.once = once;

function delegate(target, selector, type, listener, option) {
  return bind(target, type, ev => {
    const cx = ev.target.shadowRoot ? ev.composedPath()[0]?.closest(selector) : ev.target?.closest(selector);
    cx && once(cx, type, e => {
      e === ev && listener(ev);
    }, option);
  }, { ...(typeof option === 'boolean' ? {
      capture: true
    } : option),
    capture: true
  });
}

exports.delegate = delegate;

function bind(target, type, listener, option) {
  switch (type) {
    case 'mutate':
    case 'connect':
    case 'disconnect':
      const prop = `on${type}`;
      target[prop] ?? global_1.Object.defineProperty(target, prop, {
        configurable: true,
        enumerable: false,
        writable: true,
        value: prop in target && !(0, alias_1.hasOwnProperty)(target, prop) ? ev => ev.returnValue : ''
      });
  }

  target.addEventListener(type, handler, option);
  return (0, function_1.singleton)(() => void target.removeEventListener(type, handler, option));

  function handler(ev) {
    ev[exports.currentTarget] = ev.currentTarget;
    listener(ev);
  }
}

exports.bind = bind;

/***/ }),

/***/ 160:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.querySelectorAll = exports.querySelectorAllWith = exports.querySelectorWith = void 0;

const global_1 = __webpack_require__(128);

const duff_1 = __webpack_require__(99);

function querySelectorWith(node, selector) {
  return 'matches' in node && node.matches(selector) ? node : node.querySelector(selector);
}

exports.querySelectorWith = querySelectorWith;

function querySelectorAllWith(node, selector) {
  const acc = [];

  if ('matches' in node && node.matches(selector)) {
    acc.push(node);
  }

  return (0, duff_1.duffReduce)(node.querySelectorAll(selector), (acc, el) => (acc.push(el), acc), acc);
}

exports.querySelectorAllWith = querySelectorAllWith;

function querySelectorAll(node, selector) {
  return (0, duff_1.duffReduce)(node.querySelectorAll(selector), (acc, el) => (acc.push(el), acc), (0, global_1.Array)());
}

exports.querySelectorAll = querySelectorAll;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
var exports = __webpack_exports__;


Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.identity = exports.querySelectorAllWith = exports.querySelectorWith = exports.querySelectorAll = exports.currentTarget = exports.once = exports.bind = exports.delegate = exports.listen = exports.defrag = exports.prepend = exports.append = exports.define = exports.element = exports.text = exports.svg = exports.html = exports.frag = exports.shadow = exports.SVG = exports.HTML = exports.Shadow = exports.API = void 0;

__webpack_require__(128);

var builder_1 = __webpack_require__(48);

Object.defineProperty(exports, "API", ({
  enumerable: true,
  get: function () {
    return builder_1.API;
  }
}));
Object.defineProperty(exports, "Shadow", ({
  enumerable: true,
  get: function () {
    return builder_1.Shadow;
  }
}));
Object.defineProperty(exports, "HTML", ({
  enumerable: true,
  get: function () {
    return builder_1.HTML;
  }
}));
Object.defineProperty(exports, "SVG", ({
  enumerable: true,
  get: function () {
    return builder_1.SVG;
  }
}));

var dom_1 = __webpack_require__(521);

Object.defineProperty(exports, "shadow", ({
  enumerable: true,
  get: function () {
    return dom_1.shadow;
  }
}));
Object.defineProperty(exports, "frag", ({
  enumerable: true,
  get: function () {
    return dom_1.frag;
  }
}));
Object.defineProperty(exports, "html", ({
  enumerable: true,
  get: function () {
    return dom_1.html;
  }
}));
Object.defineProperty(exports, "svg", ({
  enumerable: true,
  get: function () {
    return dom_1.svg;
  }
}));
Object.defineProperty(exports, "text", ({
  enumerable: true,
  get: function () {
    return dom_1.text;
  }
}));
Object.defineProperty(exports, "element", ({
  enumerable: true,
  get: function () {
    return dom_1.element;
  }
}));
Object.defineProperty(exports, "define", ({
  enumerable: true,
  get: function () {
    return dom_1.define;
  }
}));
Object.defineProperty(exports, "append", ({
  enumerable: true,
  get: function () {
    return dom_1.append;
  }
}));
Object.defineProperty(exports, "prepend", ({
  enumerable: true,
  get: function () {
    return dom_1.prepend;
  }
}));
Object.defineProperty(exports, "defrag", ({
  enumerable: true,
  get: function () {
    return dom_1.defrag;
  }
}));

var listener_1 = __webpack_require__(251);

Object.defineProperty(exports, "listen", ({
  enumerable: true,
  get: function () {
    return listener_1.listen;
  }
}));
Object.defineProperty(exports, "delegate", ({
  enumerable: true,
  get: function () {
    return listener_1.delegate;
  }
}));
Object.defineProperty(exports, "bind", ({
  enumerable: true,
  get: function () {
    return listener_1.bind;
  }
}));
Object.defineProperty(exports, "once", ({
  enumerable: true,
  get: function () {
    return listener_1.once;
  }
}));
Object.defineProperty(exports, "currentTarget", ({
  enumerable: true,
  get: function () {
    return listener_1.currentTarget;
  }
}));

var query_1 = __webpack_require__(160);

Object.defineProperty(exports, "querySelectorAll", ({
  enumerable: true,
  get: function () {
    return query_1.querySelectorAll;
  }
}));
Object.defineProperty(exports, "querySelectorWith", ({
  enumerable: true,
  get: function () {
    return query_1.querySelectorWith;
  }
}));
Object.defineProperty(exports, "querySelectorAllWith", ({
  enumerable: true,
  get: function () {
    return query_1.querySelectorAllWith;
  }
}));

var identity_1 = __webpack_require__(670);

Object.defineProperty(exports, "identity", ({
  enumerable: true,
  get: function () {
    return identity_1.identity;
  }
}));
})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});